// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from robot_controllers_msgs:msg/DiffDriveLimiterParams.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CONTROLLERS_MSGS__MSG__DETAIL__DIFF_DRIVE_LIMITER_PARAMS__STRUCT_H_
#define ROBOT_CONTROLLERS_MSGS__MSG__DETAIL__DIFF_DRIVE_LIMITER_PARAMS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/DiffDriveLimiterParams in the package robot_controllers_msgs.
/**
  * Various parameters for diff driver base velocity and acceleration limiter
  * This message allows limits that would imposed by diff_drive_base
  * to be understood by other components without needing access to 
  * same set of rosparams, or URDF settings
 */
typedef struct robot_controllers_msgs__msg__DiffDriveLimiterParams
{
  double max_linear_velocity;
  double max_linear_acceleration;
  double max_angular_velocity;
  double max_angular_acceleration;
  /// Wheel velocity limit are linear velocity (m/s) not angular velocities (rad/s)
  double max_wheel_velocity;
  /// distance between two wheels
  /// used for calculating wheel velocities from angular velocity
  double track_width;
  /// If true limiter will reduce linear velocity
  /// when angular velocity is beyond limit so
  /// so path curvature is maintained
  bool angular_velocity_limits_linear_velocity;
  /// If true, linear and angular velocities will
  /// scaled if wheel velocities beyond limits
  /// so path curvature is maintained
  /// otherwise wheel velocities are limited independently
  bool scale_to_wheel_velocity_limits;
} robot_controllers_msgs__msg__DiffDriveLimiterParams;

// Struct for a sequence of robot_controllers_msgs__msg__DiffDriveLimiterParams.
typedef struct robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence
{
  robot_controllers_msgs__msg__DiffDriveLimiterParams * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ROBOT_CONTROLLERS_MSGS__MSG__DETAIL__DIFF_DRIVE_LIMITER_PARAMS__STRUCT_H_
